using System;

namespace Cerebrum.Ganglion.Ensemble
{
	/// <summary>
	/// Summary description for Application.
	/// </summary>
	public class Application : Cerebrum.Integrator.Application
	{
		public Application()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		protected override Cerebrum.Integrator.IContextService CreateContextService()
		{
			string primaryDirectory = m_MasterContext!=null?(m_MasterContext.SystemDirectory):System.IO.Path.GetDirectoryName(this.GetType().Assembly.Location);
			string databaseFileName = System.IO.Path.Combine(primaryDirectory, "Cerebrum.Database.Master.bin");
			string activityFileName = System.IO.Path.Combine(primaryDirectory, "Cerebrum.Database.Master.log");
			string mergeFileName = System.IO.Path.Combine(primaryDirectory, "Cerebrum.Database.Master.xdb");

			return new Cerebrum.Management.SimpleContextService(this, databaseFileName, activityFileName, 8, true, mergeFileName, true);
		}

		public override Cerebrum.Integrator.DomainContext CreateMasterContext(string domainName, bool creating)
		{
			return new Cerebrum.Integrator.DomainContext(this);
		}

		public override void ProcessException(Exception ex, string source)
		{
			try
			{
				lock (this)
				{
					string primaryDirectory = m_MasterContext != null ? (m_MasterContext.SystemDirectory) : System.IO.Path.GetDirectoryName(this.GetType().Assembly.Location);
					string activityFileName = System.IO.Path.Combine(primaryDirectory, "Cerebrum.Database.Master.txt");
					using (System.IO.FileStream fs = new System.IO.FileStream(activityFileName, System.IO.FileMode.Append))
					{
						using (System.IO.StreamWriter sw = new System.IO.StreamWriter(fs, System.Text.Encoding.Default))
						{
							string text = System.DateTime.Now.ToString() + ": " + source + System.Environment.NewLine;
							text += ex.ToString() + System.Environment.NewLine;
							sw.WriteLine(text);
						}
					}
				}
			}
			catch
			{
			}
		}

	}
}
