using System;

namespace Cerebrum.Ganglion.Ensemble
{
	/// <summary>
	/// Summary description for DatabaseInterface.
	/// </summary>
	public class RemoteDatabase : System.MarshalByRefObject, Cerebrum.Ganglion.Remoting.IRemoteDatabase
	{
		public RemoteDatabase()
		{
			//
			// TODO: Add constructor logic here
			//
		}
		private class ArrayComparer : System.Collections.IComparer
		{
			Cerebrum.Ganglion.Remoting.OrderDirection[] OrderDirections;
			public ArrayComparer(Cerebrum.Ganglion.Remoting.OrderDirection[] drords)
			{
				OrderDirections = drords;
			}

			#region IComparer Members

			public int Compare(object x, object y)
			{
				System.Array ax = x as System.Array;
				System.Array ay = y as System.Array;
				for (int i = 0; i < this.OrderDirections.Length; i++)
				{
					object ox = ax.GetValue(i);
					object oy = ay.GetValue(i);
					System.IComparable c = ox as System.IComparable;
					int r = c.CompareTo(oy);
					if (r != 0)
						if (this.OrderDirections[i] == Cerebrum.Ganglion.Remoting.OrderDirection.Ascending)
						{
							return r;
						}
						else
						{
							return -r;
						}
				}
				return 0;
			}

			#endregion
		}

		private static Cerebrum.Ganglion.Remoting.TableDef FromView(System.ComponentModel.IBindingList view, string[] columns, int from, int count, object query)
		{
			Cerebrum.Ganglion.Remoting.TableDef qr = new Cerebrum.Ganglion.Remoting.TableDef();
			qr.Count = view.Count;
			System.ComponentModel.PropertyDescriptorCollection pds = (view as System.ComponentModel.ITypedList).GetItemProperties(null);
			qr.Fields = new Cerebrum.Ganglion.Remoting.FieldDef[columns.Length];
			for (int c = 0; c < columns.Length; c++)
			{
				string column = columns[c];
				System.ComponentModel.PropertyDescriptor pd = pds[column];
				System.Type propType = pd.PropertyType;
				qr.Fields[c] = new Cerebrum.Ganglion.Remoting.FieldDef(column, propType);
			}
			if (count != 0 && from < view.Count)
			{
				int _f, _t;
				if (from >= 0)
				{
					_f = from;
				}
				else
				{
					_f = 0;
				}
				if (count >= 0)
				{
					int to = _f + count - 1;
					if (to < view.Count)
					{
						_t = to;
					}
					else
					{
						_t = view.Count - 1;
					}
				}
				else
				{
					_t = view.Count - 1;
				}
				if (_f <= _t)
				{
					qr.Tuples = new Cerebrum.Ganglion.Remoting.TupleDef[_t - _f + 1];
					Cerebrum.Ganglion.Remoting.QueryDef qdf = query as Cerebrum.Ganglion.Remoting.QueryDef;
					System.Collections.SortedList map = null;
					if (qdf != null && qdf.OrderBy != null && qdf.OrderBy.Length > 0)
					{
						System.ComponentModel.PropertyDescriptor[] pdords = new System.ComponentModel.PropertyDescriptor[qdf.OrderBy.Length];
						Cerebrum.Ganglion.Remoting.OrderDirection[] drords = new Cerebrum.Ganglion.Remoting.OrderDirection[qdf.OrderBy.Length];
						for (int i = 0; i < pdords.Length; i++)
						{
							pdords[i] = pds[qdf.OrderBy[i].Name];
							drords[i] = qdf.OrderBy[i].Direction;
						}
						map = new System.Collections.SortedList(new ArrayComparer(drords));
						for (int r = 0; r < view.Count; r++)
						{
							object[] values = new object[pdords.Length];
							object or = view[r];
							for (int i = 0; i < pdords.Length; i++)
							{
								values[i] = pdords[i].GetValue(or);
							}
							map.Add(values, r);
						}
					}
					for (int i = _f, r = 0; i <= _t; i++, r++)
					{
						qr.Tuples[r].Values = new object[columns.Length];
						object or;
						if (map == null)
						{
							or = view[i];
						}
						else
						{
							or = view[(int)map.GetByIndex(i)];
						}

						for (int c = 0; c < columns.Length; c++)
						{
							string column = columns[c];
							System.ComponentModel.PropertyDescriptor pd = pds[column];
							if (pd.PropertyType == typeof(System.ComponentModel.IBindingList))
							{
								System.ComponentModel.PropertyDescriptorCollection pds2 = ((System.ComponentModel.ITypedList)pd.GetValue(or)).GetItemProperties(null);
								System.ComponentModel.PropertyDescriptor pdobjh = pds2["ObjectHandle"];
								System.Collections.IList cll = (System.Collections.IList)pd.GetValue(or);
								Cerebrum.ObjectHandle []harr = new ObjectHandle[cll.Count];
								for (int i2 = 0; i2 < cll.Count; i2++)
								{
									harr[i2] = (Cerebrum.ObjectHandle)pdobjh.GetValue(cll[i2]);
								}
								qr.Tuples[r].Values[c] = harr;
							}
							else
							{
								qr.Tuples[r].Values[c] = pd.GetValue(or);
							}
						}
					}
				}
			}
			return qr;
		}

		#region IRemoteDatabase Members

		public bool UpdateRecord(string dbName, string tableName, Cerebrum.ObjectHandle handle, string[] columns, object[] values)
		{
			Cerebrum.Ganglion.Remoting.IEnsembleController ensemble = new Cerebrum.Ganglion.Ensemble.EnsembleController();
			Cerebrum.Ganglion.Remoting.IDatabaseController database = ensemble.GetDatabaseController(dbName, true);
			return database.UpdateRecord(tableName, handle, columns, values);
		}

		public bool DeleteRecord(string dbName, string tableName, Cerebrum.ObjectHandle handle)
		{
			Cerebrum.Ganglion.Remoting.IEnsembleController ensemble = new Cerebrum.Ganglion.Ensemble.EnsembleController();
			Cerebrum.Ganglion.Remoting.IDatabaseController database = ensemble.GetDatabaseController(dbName, true);
			return database.DeleteRecord(tableName, handle);
		}

		public object[] SelectRecord(string dbName, string tableName, Cerebrum.ObjectHandle handle, string[] columns)
		{
			Cerebrum.Ganglion.Remoting.IEnsembleController ensemble = new Cerebrum.Ganglion.Ensemble.EnsembleController();
			Cerebrum.Ganglion.Remoting.IDatabaseController database = ensemble.GetDatabaseController(dbName, true);
			return database.SelectRecord(tableName, handle, columns);
		}

		public Cerebrum.ObjectHandle InsertRecord(string dbName, string tableName, string[] columns, object[] values)
		{
			Cerebrum.Ganglion.Remoting.IEnsembleController ensemble = new Cerebrum.Ganglion.Ensemble.EnsembleController();
			Cerebrum.Ganglion.Remoting.IDatabaseController database = ensemble.GetDatabaseController(dbName, true);
			return database.InsertRecord(tableName, columns, values);
		}


		public Cerebrum.Ganglion.Remoting.TableDef QueryTable(string dbName, string tableName, string[] columns, int from, int count, object query)
		{
			Cerebrum.Ganglion.Remoting.IEnsembleController ensemble = new Cerebrum.Ganglion.Ensemble.EnsembleController();
			Cerebrum.Ganglion.Ensemble.IDatabaseController database = ensemble.GetDatabaseController(dbName, true) as Cerebrum.Ganglion.Ensemble.IDatabaseController;
			lock (ensemble.SyncRoot)
			{
				Cerebrum.Integrator.DomainContext domain = Cerebrum.Integrator.DomainContext.FromConnector(database.Workspace as Cerebrum.IConnector);
				using (Cerebrum.Data.TableView view = Cerebrum.Management.Utilites.GetView(domain, tableName))
				{
					return FromView(view, columns, from, count, query);
				}
			}
		}

		public Cerebrum.Ganglion.Remoting.TableDef QueryRecord(string dbName, string tableName, string fieldName, ObjectHandle handle, string[] columns, int from, int count, object query)
		{
			Cerebrum.Ganglion.Remoting.IEnsembleController ensemble = new Cerebrum.Ganglion.Ensemble.EnsembleController();
			Cerebrum.Ganglion.Ensemble.IDatabaseController database = ensemble.GetDatabaseController(dbName, true) as Cerebrum.Ganglion.Ensemble.IDatabaseController;
			lock (ensemble.SyncRoot)
			{
				Cerebrum.Integrator.DomainContext domain = Cerebrum.Integrator.DomainContext.FromConnector(database.Workspace as Cerebrum.IConnector);
				using (Cerebrum.Data.TableView view = Cerebrum.Management.Utilites.GetView(domain, tableName))
				{
					System.ComponentModel.PropertyDescriptor pd = (view as System.ComponentModel.ITypedList).GetItemProperties(null)[fieldName];
					object o = view.CreateItemViewByObjectHandle(handle);
					object v = pd.GetValue(o);
					if(v is Cerebrum.Data.SimpleView)
						using (Cerebrum.Data.SimpleView view2 = (Cerebrum.Data.SimpleView)v)
						{
							return FromView(view2, columns, from, count, query);
						}
				}
			}
			return null;
		}

		public object InvokeRecord(string databaseName, string tableName, ObjectHandle handle, string method, object[] parameters)
		{
			Cerebrum.Ganglion.Remoting.IEnsembleController ensemble = new Cerebrum.Ganglion.Ensemble.EnsembleController();
			Cerebrum.Ganglion.Remoting.IDatabaseController database = ensemble.GetDatabaseController(databaseName, true);
			return database.InvokeRecord(tableName, handle, method, parameters);
		}

		public object InvokeComponent(string databaseName, /*string tableName, */string componentName, string method, object[] parameters)
		{
			Cerebrum.Ganglion.Remoting.IEnsembleController ensemble = new Cerebrum.Ganglion.Ensemble.EnsembleController();
			Cerebrum.Ganglion.Remoting.IDatabaseController database = ensemble.GetDatabaseController(databaseName, true);
			string tableName = "Components";
			Cerebrum.ObjectHandle handle = database.ResolveHandle(tableName, "Name", componentName);
			return database.InvokeRecord(tableName, handle, method, parameters);
		}

		public bool EngageRecord(string databaseName, string tableName, ObjectHandle handle)
		{
			Cerebrum.Ganglion.Remoting.IEnsembleController ensemble = new Cerebrum.Ganglion.Ensemble.EnsembleController();
			Cerebrum.Ganglion.Remoting.IDatabaseController database = ensemble.GetDatabaseController(databaseName, true);
			return database.EngageRecord(tableName, handle);
		}


		public ObjectHandle ResolveHandle(string databaseName, string tableName, string fieldName, object value)
		{
			Cerebrum.Ganglion.Remoting.IEnsembleController ensemble = new Cerebrum.Ganglion.Ensemble.EnsembleController();
			Cerebrum.Ganglion.Remoting.IDatabaseController database = ensemble.GetDatabaseController(databaseName, true);
			return database.ResolveHandle(tableName, fieldName, value);
		}

		public void Shutdown(string databaseName)
		{
			Cerebrum.Ganglion.Remoting.IEnsembleController ensemble = new Cerebrum.Ganglion.Ensemble.EnsembleController();
			Cerebrum.Ganglion.Remoting.IDatabaseController database = ensemble.GetDatabaseController(databaseName, false);
			database.Shutdown();
		}

		public void Impersonate(System.Security.Principal.IPrincipal principal)
		{
			System.Threading.Thread.CurrentPrincipal = principal;
		}

		#endregion
	}
	/*
	private static System.Data.DataTable FromView(System.ComponentModel.IBindingList view, string[] columns, int from, int to)
	{
		System.Data.DataTable dt = new System.Data.DataTable();
		System.ComponentModel.PropertyDescriptorCollection pds = (view as System.ComponentModel.ITypedList).GetItemProperties(null);
		foreach (string column in columns)
		{
			System.ComponentModel.PropertyDescriptor pd = pds[column];
			System.Type propType = pd.PropertyType;
			System.Data.DataColumn dc;
			if (propType == typeof(Cerebrum.ObjectHandle))
			{
				propType = typeof(System.Int32);
				dc = new System.Data.DataColumn(column, propType, null, System.Data.MappingType.Attribute);
			}
			else
			{
				dc = new System.Data.DataColumn(column, propType, null, System.Data.MappingType.Element);
			}
			dt.Columns.Add(dc);
		}
		int _f, _t;
		if (from >= 0)
		{
			_f = from;
		}
		else
		{
			_f = 0;
		}
		if (to >= 0)
		{
			if (to < view.Count)
			{
				_t = to;
			}
			else
			{
				_t = view.Count - 1;
			}
		}
		else
		{
			_t = view.Count - 1;
		}
		for (int i = _f; i <= _t; i++)
		{
			object or = view[i];
			System.Data.DataRow dr = dt.NewRow();
			foreach (string column in columns)
			{
				System.ComponentModel.PropertyDescriptor pd = pds[column];
				System.Data.DataColumn dc = dt.Columns[column];

				if (pd.PropertyType == typeof(Cerebrum.ObjectHandle))
				{
					dr[dc] = ((Cerebrum.ObjectHandle)pd.GetValue(or)).ToInt32();
				}
				else
				{
					dr[dc] = pd.GetValue(or);
				}

			}
			dt.Rows.Add(dr);
		}
		return dt;
	}
	*/
}
