using System;

namespace Cerebrum.Ganglion.Ensemble
{
	/// <summary>
	/// Summary description for SyncronizedConnector.
	/// </summary>
	public class SyncronizedConnector : System.MarshalByRefObject, Cerebrum.IConnector
	{
		private Cerebrum.IConnector m_Connector;
		public SyncronizedConnector(Cerebrum.IConnector connector)
		{
			m_Connector = connector;
		}
		#region IConnector Members

		public object Component
		{
			get
			{
				lock(ControllerImplementation.SyncRoot)
				{
					return m_Connector.Component;
				}
			}
			set
			{
				lock(ControllerImplementation.SyncRoot)
				{
					m_Connector.Component = value;
				}
			}
		}

		public Cerebrum.IWorkspace Workspace
		{
			get
			{
				lock(ControllerImplementation.SyncRoot)
				{
					return new SyncronizedWorkspace(m_Connector.Workspace);
				}
			}
		}

		#endregion

		#region IDisposable Members

		public event System.EventHandler Disposing
		{
			add
			{
			}
			remove
			{
			}
		}

		#endregion

		#region IDisposable Members

		public void Dispose()
		{
			lock(ControllerImplementation.SyncRoot)
			{
				m_Connector.Dispose();
			}
		}

		#endregion
	}
}
