// Copyright (C) Dmitry Shuklin 2003-2007. All rights reserved.

using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace Cerebrum.Data.Manager.Forms
{
	/// <summary>
	/// Summary description for BindableTextBox.
	/// </summary>
	public class BindableTextBox : System.Windows.Forms.TextBox
	{
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public BindableTextBox()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call
			this.m_ValueType = null;

		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			components = new System.ComponentModel.Container();
		}
		#endregion

		private System.Type m_ValueType;
		public System.Type ValueType
		{
			get
			{
				return this.m_ValueType;
			}
			set
			{
				this.m_ValueType = value;
			}
		}
		public object Value
		{
			get
			{
				if(this.Text==string.Empty)
				{
					return System.DBNull.Value;
				}
				else if(m_ValueType!=null)
				{
					return System.ComponentModel.TypeDescriptor.GetConverter(this.m_ValueType).ConvertFromString(this.Text);
				}
				else
				{
					return this.Text;
				}
			}
			set
			{
				/*if(value!=null && !Convert.IsDBNull(value))
				{
					m_ValueType = value.GetType();
				}
				else
				{
					m_ValueType = null;
				}*/
				this.Text = Convert.ToString(value);
			}
		}
	}
}
