// Copyright (C) Dmitry Shuklin 2003-2007. All rights reserved.

using System;

namespace Cerebrum.Windows.Forms.ComponentModel
{
	/// <summary>
	/// Summary description for UiService.
	/// </summary>
	internal class UiService
	{
		Cerebrum.Integrator.DomainContext m_Context;
		Cerebrum.ObjectHandle m_Handle;

		public UiService(Cerebrum.Integrator.DomainContext context, Cerebrum.ObjectHandle handle)
		{
			m_Context = context;
			m_Handle = handle;
		}

		public void CommandActivated(object sender, Cerebrum.Windows.Forms.ConnectorEventArgs e)
		{
			e.Cancel |= this.ActivateCommand(e.Connector, sender, null);
		}

		public bool ActivateCommand(Cerebrum.IConnector connectorMsg, object sender, object argument)
		{
			using(Cerebrum.IConnector connector = m_Context.AttachConnector(m_Handle))
			{
				return ((Cerebrum.Windows.Forms.Reflection.UiServiceDescriptor)connector.Component).CommandActivated(connectorMsg, sender, argument);
			}
		}

		public void ComponentActivated(object component)
		{
			using(Cerebrum.IConnector connector = m_Context.AttachConnector(m_Handle))
			{
				((Cerebrum.Windows.Forms.Reflection.UiServiceDescriptor)connector.Component).ComponentActivated(component);
			}
		}
	}
}
