// Copyright (C) Dmitry Shuklin 2003-2007. All rights reserved.

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Cerebrum.DesktopEngine
{
	/// <summary>
	/// Summary description for EmergencyConfigurator.
	/// </summary>
	public class EmergencyConfigurator : Cerebrum.Windows.Forms.VisualComponent 
	{
		private System.Windows.Forms.TabControl tabControl1;
		private System.Windows.Forms.TabPage tbpTools;
		private System.Windows.Forms.TabPage tbpTables;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.TextBox txtReport;
		private System.Windows.Forms.DataGrid dgTables;
		private System.Windows.Forms.Button btnImport;
		private System.Windows.Forms.Button btnExport;
		private System.Windows.Forms.Button btnReport;
		private System.Windows.Forms.Button btnCollect;
		private System.Windows.Forms.Button btnShutdown;
		private System.Windows.Forms.CheckBox chkHasChanges;
		private System.Windows.Forms.Button btnBeginTran;
		private System.Windows.Forms.Button btnCommitTran;
		private System.Windows.Forms.Button btnRollbackTran;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public EmergencyConfigurator()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.tabControl1 = new System.Windows.Forms.TabControl();
			this.tbpTools = new System.Windows.Forms.TabPage();
			this.txtReport = new System.Windows.Forms.TextBox();
			this.panel1 = new System.Windows.Forms.Panel();
			this.btnCommitTran = new System.Windows.Forms.Button();
			this.btnBeginTran = new System.Windows.Forms.Button();
			this.chkHasChanges = new System.Windows.Forms.CheckBox();
			this.btnShutdown = new System.Windows.Forms.Button();
			this.btnImport = new System.Windows.Forms.Button();
			this.btnExport = new System.Windows.Forms.Button();
			this.btnReport = new System.Windows.Forms.Button();
			this.btnCollect = new System.Windows.Forms.Button();
			this.btnRollbackTran = new System.Windows.Forms.Button();
			this.tbpTables = new System.Windows.Forms.TabPage();
			this.dgTables = new System.Windows.Forms.DataGrid();
			this.tabControl1.SuspendLayout();
			this.tbpTools.SuspendLayout();
			this.panel1.SuspendLayout();
			this.tbpTables.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.dgTables)).BeginInit();
			this.SuspendLayout();
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.Add(this.tbpTools);
			this.tabControl1.Controls.Add(this.tbpTables);
			this.tabControl1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.tabControl1.Location = new System.Drawing.Point(0, 0);
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.Size = new System.Drawing.Size(704, 509);
			this.tabControl1.TabIndex = 0;
			this.tabControl1.SelectedIndexChanged += new System.EventHandler(this.tabControl1_SelectedIndexChanged);
			// 
			// tbpTools
			// 
			this.tbpTools.Controls.Add(this.txtReport);
			this.tbpTools.Controls.Add(this.panel1);
			this.tbpTools.Location = new System.Drawing.Point(4, 22);
			this.tbpTools.Name = "tbpTools";
			this.tbpTools.Size = new System.Drawing.Size(696, 483);
			this.tbpTools.TabIndex = 0;
			this.tbpTools.Text = "Tools";
			// 
			// txtReport
			// 
			this.txtReport.Dock = System.Windows.Forms.DockStyle.Fill;
			this.txtReport.Location = new System.Drawing.Point(0, 56);
			this.txtReport.Multiline = true;
			this.txtReport.Name = "txtReport";
			this.txtReport.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.txtReport.Size = new System.Drawing.Size(696, 427);
			this.txtReport.TabIndex = 1;
			this.txtReport.Text = "";
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.btnCommitTran);
			this.panel1.Controls.Add(this.btnBeginTran);
			this.panel1.Controls.Add(this.chkHasChanges);
			this.panel1.Controls.Add(this.btnShutdown);
			this.panel1.Controls.Add(this.btnImport);
			this.panel1.Controls.Add(this.btnExport);
			this.panel1.Controls.Add(this.btnReport);
			this.panel1.Controls.Add(this.btnCollect);
			this.panel1.Controls.Add(this.btnRollbackTran);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(696, 56);
			this.panel1.TabIndex = 0;
			// 
			// btnCommitTran
			// 
			this.btnCommitTran.Location = new System.Drawing.Point(560, 32);
			this.btnCommitTran.Name = "btnCommitTran";
			this.btnCommitTran.TabIndex = 19;
			this.btnCommitTran.Text = "Commit Tran";
			this.btnCommitTran.Click += new System.EventHandler(this.btnCommitTran_Click);
			// 
			// btnBeginTran
			// 
			this.btnBeginTran.Location = new System.Drawing.Point(560, 8);
			this.btnBeginTran.Name = "btnBeginTran";
			this.btnBeginTran.TabIndex = 18;
			this.btnBeginTran.Text = "Begin Tran";
			this.btnBeginTran.Click += new System.EventHandler(this.btnBeginTran_Click);
			// 
			// chkHasChanges
			// 
			this.chkHasChanges.Location = new System.Drawing.Point(440, 16);
			this.chkHasChanges.Name = "chkHasChanges";
			this.chkHasChanges.TabIndex = 17;
			this.chkHasChanges.Text = "Has Changes";
			this.chkHasChanges.CheckedChanged += new System.EventHandler(this.chkHasChanges_CheckedChanged);
			// 
			// btnShutdown
			// 
			this.btnShutdown.Location = new System.Drawing.Point(96, 16);
			this.btnShutdown.Name = "btnShutdown";
			this.btnShutdown.TabIndex = 16;
			this.btnShutdown.Text = "Shutdown";
			this.btnShutdown.Click += new System.EventHandler(this.btnShutdown_Click);
			// 
			// btnImport
			// 
			this.btnImport.Location = new System.Drawing.Point(352, 16);
			this.btnImport.Name = "btnImport";
			this.btnImport.TabIndex = 15;
			this.btnImport.Text = "Import";
			this.btnImport.Click += new System.EventHandler(this.btnImport_Click);
			// 
			// btnExport
			// 
			this.btnExport.Location = new System.Drawing.Point(272, 16);
			this.btnExport.Name = "btnExport";
			this.btnExport.TabIndex = 14;
			this.btnExport.Text = "Export";
			this.btnExport.Click += new System.EventHandler(this.btnExport_Click);
			// 
			// btnReport
			// 
			this.btnReport.Location = new System.Drawing.Point(192, 16);
			this.btnReport.Name = "btnReport";
			this.btnReport.TabIndex = 13;
			this.btnReport.Text = "Report";
			this.btnReport.Click += new System.EventHandler(this.btnReport_Click);
			// 
			// btnCollect
			// 
			this.btnCollect.Location = new System.Drawing.Point(8, 16);
			this.btnCollect.Name = "btnCollect";
			this.btnCollect.TabIndex = 12;
			this.btnCollect.Text = "Collect";
			this.btnCollect.Click += new System.EventHandler(this.btnCollect_Click);
			// 
			// btnRollbackTran
			// 
			this.btnRollbackTran.Location = new System.Drawing.Point(640, 8);
			this.btnRollbackTran.Name = "btnRollbackTran";
			this.btnRollbackTran.TabIndex = 19;
			this.btnRollbackTran.Text = "Rollback Tran";
			this.btnRollbackTran.Click += new System.EventHandler(this.btnRollbackTran_Click);
			// 
			// tbpTables
			// 
			this.tbpTables.Controls.Add(this.dgTables);
			this.tbpTables.Location = new System.Drawing.Point(4, 22);
			this.tbpTables.Name = "tbpTables";
			this.tbpTables.Size = new System.Drawing.Size(696, 483);
			this.tbpTables.TabIndex = 1;
			this.tbpTables.Text = "Tables";
			// 
			// dgTables
			// 
			this.dgTables.DataMember = "";
			this.dgTables.Dock = System.Windows.Forms.DockStyle.Fill;
			this.dgTables.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dgTables.Location = new System.Drawing.Point(0, 0);
			this.dgTables.Name = "dgTables";
			this.dgTables.Size = new System.Drawing.Size(696, 483);
			this.dgTables.TabIndex = 0;
			// 
			// EmergencyConfigurator
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(704, 509);
			this.Controls.Add(this.tabControl1);
			this.Name = "EmergencyConfigurator";
			this.ShowInTaskbar = false;
			this.Text = "EmergencyConfigurator";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.EmergencyConfigurator_Closing);
			this.tabControl1.ResumeLayout(false);
			this.tbpTools.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			this.tbpTables.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.dgTables)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void btnCollect_Click(object sender, System.EventArgs e)
		{
			System.GC.Collect(3);
			System.GC.WaitForPendingFinalizers();
			System.GC.Collect();
			Cerebrum.Runtime.Environment env = Cerebrum.Runtime.Environment.Current;
			env.Collect();
		}

		private void btnReport_Click(object sender, System.EventArgs e)
		{
			Cerebrum.Runtime.Environment env = Cerebrum.Runtime.Environment.Current;
			//				env.DumpMemory(ns);
			System.IO.MemoryStream mstream;
			mstream = new System.IO.MemoryStream();
		
			env.SetStdOutStream(mstream);
			mstream.Position = 0;
			mstream.SetLength(0);
			Cerebrum.Runtime.Diagnostics.DumpMemory();

			Cerebrum.IWorkspace domain = m_Connector.Workspace;

			//				using(Cerebrum.Runtime.NativeWarden w = domain.Ground as Cerebrum.Runtime.NativeWarden)
			//				{
			//					env.DumpObject(w);
			//				}
			using(Cerebrum.Runtime.NativeWarden w = domain.GetSector() as Cerebrum.Runtime.NativeWarden)
			{
				Cerebrum.Runtime.Diagnostics.DumpObject(w);
			}
			
			mstream.Position = 0;
			System.IO.StreamReader sr = new System.IO.StreamReader(mstream);
			string s = sr.ReadToEnd();
			txtReport.Text = s;
			env.SetStdOutStream(null);
			mstream.Close();
		}

		private void btnExport_Click(object sender, System.EventArgs e)
		{
			System.Text.StringBuilder sb = new System.Text.StringBuilder();
			System.IO.StringWriter sw = new System.IO.StringWriter(sb/*, System.Text.Encoding.Default*/);
			System.Xml.XmlTextWriter xw = new System.Xml.XmlTextWriter(sw);

			xw.Formatting = System.Xml.Formatting.Indented;
			Cerebrum.Management.Utilites.ExportDatabase(m_Connector.Workspace, xw);
				
			sw.Flush();
			xw.Close();
			sw.Close();

			string sysdb = sb.ToString();

			txtReport.Text = sysdb;
		}

		private void btnImport_Click(object sender, System.EventArgs e)
		{
			System.IO.StringReader sr = new System.IO.StringReader(txtReport.Text);
			System.Xml.XmlTextReader xr = new System.Xml.XmlTextReader(sr);
			Cerebrum.Management.Utilites.ImportDatabase(m_Connector.Workspace, xr);
			xr.Close();
			sr.Close();
		}

		protected override void SetConnector(Cerebrum.SerializeDirection direction, Cerebrum.IConnector connector)
		{
			base.SetConnector (direction, connector);
			switch(direction)
			{
				case Cerebrum.SerializeDirection.Init:
				{
					chkHasChanges.Checked = this.DomainContext.HasChanges;
					break;
				}
			}
		}

		private void btnShutdown_Click(object sender, System.EventArgs e)
		{
			Cerebrum.Windows.Forms.Application.Instance.Shutdown();
		}

		private void tabControl1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if(tabControl1.SelectedTab == tbpTables)
			{
				if(dgTables.DataSource == null)
				{

					using(Cerebrum.IConnector cntr2 = m_Connector.Workspace.AttachConnector(Cerebrum.Specialized.Concepts.TablesTableId))
					{
						Cerebrum.Reflection.TableDescriptor tblTables = cntr2.Component as Cerebrum.Reflection.TableDescriptor;
						Cerebrum.Data.TableView vwv = tblTables.GetTableView();
						dgTables.DataSource = new Cerebrum.Data.TableSet(vwv);
					}
				}
			}
		}

		private void chkHasChanges_CheckedChanged(object sender, System.EventArgs e)
		{
			this.DomainContext.HasChanges = chkHasChanges.Checked;
		}

		private void EmergencyConfigurator_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if(dgTables.DataSource != null)
			{
				System.IDisposable temp = dgTables.DataSource as System.IDisposable;
				dgTables.DataSource = null;
				temp.Dispose();
			}
		}

		private void btnBeginTran_Click(object sender, System.EventArgs e)
		{
			this.DomainContext.BeginTransaction(true);
		}

		private void btnCommitTran_Click(object sender, System.EventArgs e)
		{
			this.DomainContext.CommitTransaction();
		}

		private void btnRollbackTran_Click(object sender, System.EventArgs e)
		{
			this.DomainContext.RollbackTransaction();
		}

	}
}
