// Copyright (C) Dmitry Shuklin 2003-2007. All rights reserved.

using System;

namespace Cerebrum.Integrator
{
	/// <summary>
	/// Summary description for Activator.
	/// </summary>
	public class Activator : Cerebrum.IActivator
	{
		public Activator()
		{
			//
			// TODO: Add constructor logic here
			//
		}
		/*#region IObjectActivator Members

		public Cerebrum.ObjectHandle CreateTypeRecord(Cerebrum.IConnector domain, Type type)
		{
			// TODO:  Add Activator.CreateTypeRecord implementation
			return new Cerebrum.ObjectHandle ();
		}

		#endregion*/

		#region IActivator Members

		void Cerebrum.IActivator.CreateInstance(Cerebrum.IConnector domain, Cerebrum.ObjectHandle typeID, object [] args, ref object instance, ref Cerebrum.ObjectHandle classType)
		{
			if(((System.IComparable)typeID).CompareTo(Cerebrum.ObjectHandle.Null) > 0)
			{
				if(typeID==Cerebrum.Specialized.Concepts.AttributeDescriptorTypeId)
				{
					classType = Cerebrum.Runtime.KernelObjectKindId.Warden;
					instance = new Cerebrum.Reflection.AttributeDescriptor();
				}
				else if(typeID==Cerebrum.Specialized.Concepts.TypeDescriptorTypeId)
				{
					classType = Cerebrum.Runtime.KernelObjectKindId.Warden;
					instance = new Cerebrum.Reflection.TypeDescriptor();
				}
				else if(typeID==Cerebrum.Specialized.Concepts.TableDescriptorTypeId)
				{
					classType = Cerebrum.Runtime.KernelObjectKindId.Warden;
					instance = new Cerebrum.Reflection.TableDescriptor();
				}
				else
				{
					Cerebrum.Runtime.INativeDomain nd = (Cerebrum.Runtime.INativeDomain)domain;

					using(Cerebrum.IContainer sector = nd.GetSector())
					{
						using(Cerebrum.IConnector ctype = sector.AttachConnector(typeID))
						{
							Cerebrum.Reflection.TypeDescriptor tds = (Cerebrum.Reflection.TypeDescriptor)ctype.Component;
							classType = tds.KernelObjectKindId;
							if(classType==Cerebrum.Runtime.KernelObjectKindId.Scalar)
							{
								instance = null;
							}
							else
							{
								System.Type componentType = tds.ComponentType;
								if(componentType.IsAbstract)
								{
									instance = null;
								}
								else
								{
									if(args==null)
									{
										instance = System.Activator.CreateInstance(componentType);
									}
									else
									{
										instance = System.Activator.CreateInstance(componentType, args);
									}
								}
							}
						}
					}
				}
			}
			else
			{
				classType = Cerebrum.Runtime.KernelObjectKindId.Warden;
				instance = null;
			}
		}

		#endregion
	}
}
