using System;

namespace Cerebrum.Samples.Objects01
{
	/// <summary>
	/// Summary description for Application.
	/// </summary>
	public class Application : Cerebrum.Windows.Forms.Application 
	{
		public Application()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		public override Cerebrum.Integrator.DomainContext CreateMasterContext(string domainName, bool creating)
		{
			return new Cerebrum.Integrator.DomainContext(this);
		}

		protected override System.Windows.Forms.Form CreatePrimaryWindow()
		{
			return new PrimaryWindow();
		}

		protected override Cerebrum.Integrator.IContextService CreateContextService()
		{
			string primaryDirectory = m_MasterContext!=null?(m_MasterContext.SystemDirectory):System.IO.Path.GetDirectoryName(this.GetType().Assembly.Location);
			string databaseFileName = System.IO.Path.Combine(primaryDirectory, "Cerebrum.Database.Master.bin");
			string activityFileName = System.IO.Path.Combine(primaryDirectory, "Cerebrum.Database.Master.log");
			string mergeFileName = System.IO.Path.Combine(primaryDirectory, "Cerebrum.Database.Master.xdb");

			return new Cerebrum.Management.SimpleContextService(this, databaseFileName, activityFileName, 4, true, mergeFileName, false);
		}

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application app = new Application();
			Cerebrum.Windows.Forms.Application.Instance = app;
			app.Initialize();
			app.Show();
			System.Windows.Forms.Application.Run(app.PrimaryWindow);
			app.Shutdown();
			app.Dispose();
		}
	}
}
