// Copyright (C) Dmitry Shuklin 2003-2007. All rights reserved.

using System;
using Cerebrum.Integrator;

namespace Cerebrum.Windows.Forms
{
	/// <summary>
	/// IntegratorMenuItem     
	///  System.Windows.Forms.MenuItem  CommandId  MenuId
	/// CommandId    ,   
	///     ;
	/// MenuId          .
	/// </summary>
	public class IntegratorMenuItem : System.Windows.Forms.MenuItem, IUiControl, IReleasable
	{
		public IntegratorMenuItem():base()
		{
			//
			// TODO: Add constructor logic here
			//
			this.Click += new EventHandler(IntegratorMenuItem_Click);
		}
		protected Cerebrum.ObjectHandle m_MenuItemId;
		[System.ComponentModel.DesignerSerializationVisibility(System.ComponentModel.DesignerSerializationVisibility.Hidden)]
		public Cerebrum.ObjectHandle MenuItemId
		{
			get
			{
				return this.m_MenuItemId;
			}
			set
			{
				this.m_MenuItemId = value;
			}
		}
		protected Cerebrum.ObjectHandle m_CommandId;

		#region IUiCommandItem Members

		[System.ComponentModel.DesignerSerializationVisibility(System.ComponentModel.DesignerSerializationVisibility.Hidden)]
		public Cerebrum.ObjectHandle CommandId
		{
			get
			{
				return m_CommandId;
			}
			set
			{
				m_CommandId = value;
			}
		}

		bool IUiControl.Enabled
		{
			get
			{
				// TODO:  Add IntegratorMenuItem.Enabled getter implementation
				return base.Enabled;
			}
			set
			{
				base.Enabled = value;
			}
		}

		public event System.ComponentModel.CancelEventHandler InvokeCommand;

		public void AttachCommand(Cerebrum.Windows.Forms.Reflection.UiCommandDescriptor command)
		{
		}

		#endregion

		private void IntegratorMenuItem_Click(object sender, EventArgs e)
		{
			if(InvokeCommand!=null)
			{
				InvokeCommand(sender, new System.ComponentModel.CancelEventArgs(false));
			}
		}
		#region IReleasable Members

		public bool Release(bool cancel)
		{
			System.ComponentModel.CancelEventArgs e = new System.ComponentModel.CancelEventArgs(cancel);
			System.ComponentModel.CancelEventHandler handler = (System.ComponentModel.CancelEventHandler)Events[Cerebrum.Specialized.EventKeys.ReleasingEvent];
			if (handler != null)
				handler(this, e);
			return e.Cancel;
		}

		/*public void Dispose(object sender, EventArgs e)
		{
			if(this.Parent!=null) this.Parent.MenuItems.Remove(this);
			OnDisposing(e);
			this.Dispose();
		}*/
		protected virtual void OnDisposing(System.EventArgs e)
		{
			System.EventHandler handler = (System.EventHandler)Events[Cerebrum.Specialized.EventKeys.DisposingEvent];
			if (handler != null)
				handler(this, e);
		}

		public event System.ComponentModel.CancelEventHandler Releasing
		{
			add	{	Events.AddHandler(Cerebrum.Specialized.EventKeys.ReleasingEvent, value);	}
			remove	{	Events.RemoveHandler(Cerebrum.Specialized.EventKeys.ReleasingEvent, value);	}
		}

		public event System.EventHandler Disposing
		{
			add	{	Events.AddHandler(Cerebrum.Specialized.EventKeys.DisposingEvent, value);	}
			remove	{	Events.RemoveHandler(Cerebrum.Specialized.EventKeys.DisposingEvent, value);	}
		}

		#endregion
	}
}
