// Copyright (C) Dmitry Shuklin 2003-2007. All rights reserved.

using System;

namespace Cerebrum.Windows.Forms.Specialized
{
	/// <summary>
	/// Summary description for Reflection.
	/// </summary>
	public sealed class Concepts
	{
		private Concepts()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		public static Cerebrum.ObjectHandle ParentIdAttribute(Cerebrum.Integrator.DomainContext context)
		{
			return Cerebrum.Management.Utilites.ResolveHandle(context, "Attributes", "Name", "ParentId");
		}
		public static Cerebrum.ObjectHandle MergeOrderAttribute(Cerebrum.Integrator.DomainContext context)
		{
			return Cerebrum.Management.Utilites.ResolveHandle(context, "Attributes", "Name", "MergeOrder");
		}
		public static Cerebrum.ObjectHandle MessageIdAttribute(Cerebrum.Integrator.DomainContext context)
		{
			return Cerebrum.Management.Utilites.ResolveHandle(context, "Attributes", "Name", "MessageId");
		}
		public static Cerebrum.ObjectHandle AttachedControlsAttribute(Cerebrum.Integrator.DomainContext context)
		{
			return Cerebrum.Management.Utilites.ResolveHandle(context, "Attributes", "Name", "AttachedControls");
		}
		public static Cerebrum.ObjectHandle OrdinalAttribute(Cerebrum.Integrator.DomainContext context)
		{
			return Cerebrum.Management.Utilites.ResolveHandle(context, "Attributes", "Name", "Ordinal");
		}
		public static Cerebrum.ObjectHandle AttachedCommandsAttribute(Cerebrum.Integrator.DomainContext context)
		{
			return Cerebrum.Management.Utilites.ResolveHandle(context, "Attributes", "Name", "AttachedCommands");
		}
		public static Cerebrum.ObjectHandle KeyCodeAttribute(Cerebrum.Integrator.DomainContext context)
		{
			return Cerebrum.Management.Utilites.ResolveHandle(context, "Attributes", "Name", "KeyCode");
		}
		public static Cerebrum.ObjectHandle WidthAttribute(Cerebrum.Integrator.DomainContext context)
		{
			return Cerebrum.Management.Utilites.ResolveHandle(context, "Attributes", "Name", "Width");
		}
		public static Cerebrum.ObjectHandle HeightAttribute(Cerebrum.Integrator.DomainContext context)
		{
			return Cerebrum.Management.Utilites.ResolveHandle(context, "Attributes", "Name", "Height");
		}
		public static Cerebrum.ObjectHandle NormalLeaveImageStreamNameAttribute(Cerebrum.Integrator.DomainContext context)
		{
			return Cerebrum.Management.Utilites.ResolveHandle(context, "Attributes", "Name", "NormalLeaveImageStreamName");
		}
		public static Cerebrum.ObjectHandle NormalEnterImageStreamNameAttribute(Cerebrum.Integrator.DomainContext context)
		{
			return Cerebrum.Management.Utilites.ResolveHandle(context, "Attributes", "Name", "NormalEnterImageStreamName");
		}
		public static Cerebrum.ObjectHandle NormalLeaveImageBinaryDataAttribute(Cerebrum.Integrator.DomainContext context)
		{
			return Cerebrum.Management.Utilites.ResolveHandle(context, "Attributes", "Name", "NormalLeaveImageBinaryData");
		}
		public static Cerebrum.ObjectHandle NormalEnterImageBinaryDataAttribute(Cerebrum.Integrator.DomainContext context)
		{
			return Cerebrum.Management.Utilites.ResolveHandle(context, "Attributes", "Name", "NormalEnterImageBinaryData");
		}

		public static Cerebrum.ObjectHandle EmergencyConfiguratorCommandId = new Cerebrum.ObjectHandle(-1);
		public static Cerebrum.ObjectHandle ApplicationHideCommandId = new Cerebrum.ObjectHandle(-2);
		public static Cerebrum.ObjectHandle ApplicationExitCommandId = new Cerebrum.ObjectHandle(-3);
		public static Cerebrum.ObjectHandle ApplicationLogOutCommandId = new Cerebrum.ObjectHandle(-4);
		public static Cerebrum.ObjectHandle ApplicationChangePasswordCommandId = new Cerebrum.ObjectHandle(-5);
		public static Cerebrum.ObjectHandle ApplicationHelpCommandId = new Cerebrum.ObjectHandle(-6);
		public static Cerebrum.ObjectHandle SystemMenuItemId = new Cerebrum.ObjectHandle(-7);
		public static Cerebrum.ObjectHandle SecurityMenuItemId = new Cerebrum.ObjectHandle(-8);
		public static Cerebrum.ObjectHandle WindowMenuItemId = new Cerebrum.ObjectHandle(-9);
		public static Cerebrum.ObjectHandle HelpMenuItemId = new Cerebrum.ObjectHandle(-10);
		public static Cerebrum.ObjectHandle ApplicationHelpAboutCommandId = new Cerebrum.ObjectHandle(-11);
		
	}
}
